 /*
 Tecnisa - Tecnologia em Informtica

 Nome: ATUALIZA_CUSTO_COMPLEMENTO

 Descrio:
  Procedimento para atualizao do valor de estoque dos tens com
  o valor do documento de complemento

 Criao:
 13/08/2001 - Roberto A. Lopes Martins

 @C:\Win_v1.53\Sql\Oracle\0509_DFESTP_Atualiza_Custo_Complemento.sql
*/

CREATE OR REPLACE PROCEDURE ATUALIZA_CUSTO_COMPLEMENTO
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_VRNOTAFISC IN NOTAFISCAL.VRNOTAFISC%TYPE)

IS

   V_CDFILIORIG  NOTAFISCAL.CDFILIAL%TYPE;
   V_NRLANCORIG  NOTAFISCAL.NRLANCTONF%TYPE;
   V_CDFILIESTQ  LANCTOESTOQ.CDFILIAL%TYPE;
   V_NRLANCESTQ  LANCTOESTOQ.NRLANCESTQ%TYPE;

   V_VRTTLANESTQ  NUMBER;
   V_VRTTLANBRUT  NUMBER;
   V_VRTTCUSENTR  NUMBER;

   V_VRLANCTOEST  NUMBER;
   V_VRLANCTOBRUT NUMBER;
   V_VRCUSTENTR   NUMBER;
   V_VRFATOCONV   NUMBER;

   V_COUNT        NUMBER;
   w_06           Char(2):= '06';
   w_S            Char(1):= 'S';

   CURSOR C_ITLANCTOEST IS
      SELECT I.NRSEQUITEM, (I.VRLANCTOEST  * QTLANCTOEST) AS VRLANCTOEST,
             (I.VRLANCTOBRUT * QTLANCTOEST) AS VRLANCTOBRUT,
             I.VRCUSTENTR, I.QTLANCTOEST,  P.VRFATOCONV, I.RowId RowId_ITLANCTOEST
      FROM PRODUTO P, ITLANCTOEST I
      WHERE I.CDFILIAL   = V_CDFILIESTQ 
        AND I.NRLANCESTQ = V_NRLANCESTQ 
        AND I.CDPRODUTO  = P.CDPRODUTO;

BEGIN

   SELECT MAX(CDFILIALIT), MAX(NRLANCTONFIT)
   INTO V_CDFILIORIG, V_NRLANCORIG
   FROM ITEMNOTAFISC
   WHERE CDFILIAL   = P_CDFILIAL 
     AND NRLANCTONF = P_NRLANCTONF;

   SELECT COUNT(*)
   INTO V_COUNT
   FROM ITEMNOTAFISC I, NOTAFISCAL N
   WHERE I.CDFILIALIT   = V_CDFILIORIG 
     AND I.NRLANCTONFIT = V_NRLANCORIG 
     AND I.CDFILIALIT   = N.CDFILIAL 
     AND I.NRLANCTONFIT = N.NRLANCTONF 
     AND N.CDTIPOOPER   = w_06
     AND N.IDENTRSAIDOP = w_S;

   IF V_COUNT = 0 THEN
      IF V_NRLANCORIG IS NOT NULL THEN
         Begin
           SELECT CDFILIAL, NRLANCESTQ
           INTO V_CDFILIESTQ, V_NRLANCESTQ
           FROM LANCTOESTOQ
           WHERE CDFILIAL   = V_CDFILIORIG
             AND NRLANCTONF = V_NRLANCORIG;
         Exception
            When No_Data_Found Then
               V_CDFILIESTQ := Null; V_NRLANCESTQ := Null;
         End;

         SELECT SUM(VRLANCTOEST  * QTLANCTOEST) AS VRTTLANESTQ,
                SUM(VRLANCTOBRUT * QTLANCTOEST) AS VRTTLANBRUT,
                SUM(VRCUSTENTR) AS VRTTCUSENTR
         INTO V_VRTTLANESTQ,
              V_VRTTLANBRUT,
              V_VRTTCUSENTR
         FROM ITLANCTOEST
         WHERE CDFILIAL   = V_CDFILIESTQ
           AND NRLANCESTQ = V_NRLANCESTQ;

         IF V_VRTTLANESTQ > 0 THEN
            FOR C_RATEIO IN C_ITLANCTOEST LOOP
               V_VRLANCTOEST  := (C_RATEIO.VRLANCTOEST / V_VRTTLANESTQ)  * P_VRNOTAFISC;
               V_VRLANCTOBRUT := (C_RATEIO.VRLANCTOBRUT / V_VRTTLANBRUT) * P_VRNOTAFISC;
               V_VRCUSTENTR   := (C_RATEIO.VRCUSTENTR / V_VRTTCUSENTR)   * P_VRNOTAFISC;

               IF (C_RATEIO.VRFATOCONV IS NULL) OR (C_RATEIO.VRFATOCONV = 0) THEN
                  V_VRFATOCONV := 1;
               ELSE
                  V_VRFATOCONV := C_RATEIO.VRFATOCONV;
               END IF;

               V_VRLANCTOEST  := (V_VRLANCTOEST / C_RATEIO.QTLANCTOEST) / V_VRFATOCONV;
               V_VRLANCTOBRUT := (V_VRLANCTOBRUT / C_RATEIO.QTLANCTOEST) / V_VRFATOCONV;

               UPDATE ITLANCTOEST
               SET VRLANCTOEST  = VRLANCTOEST  + V_VRLANCTOEST,
                   VRLANCTOBRUT = VRLANCTOBRUT + V_VRLANCTOBRUT,
                   VRCUSTENTR   = VRCUSTENTR   + V_VRCUSTENTR
               WHERE RowId = C_RATEIO.RowId_ITLANCTOEST;
            END LOOP;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_CUSTO_COMPLEMENTO','4.11.108'); END;
/

