/* Sistemas Integrados TECNISA

Nome: 0211_GERTRGO.SQL

Descrio:
Trigger para jogar a descrio do cadastro de bairro no cadastro de endereo

Criao:
03/01/2004 Raphael Freitas Pinheiro
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_CTRLEST' AND
      	        TYPE = 'P' 			         AND
	              U.UID = O.UID             	AND
      	        U.NAME = USER)

DROP TRIGGER ATUALIZA_NMBAIRRO
GO

CREATE TRIGGER ATUALIZA_NMBAIRRO ON BAIRRO
FOR UPDATE
AS

DECLARE @V_COUNT FLOAT;
DECLARE @OLD_CDPAIS VARCHAR(4);
DECLARE @OLD_SGESTADO VARCHAR(2);
DECLARE @OLD_CDMUNICIPIO VARCHAR(4);
DECLARE @OLD_CDBAIRRO VARCHAR(10);
DECLARE @OLD_NMBAIRRO VARCHAR(50);
DECLARE @NEW_NMBAIRRO VARCHAR(50);

BEGIN
   SELECT
       @OLD_CDPAIS      = D.CDPAIS,
       @OLD_SGESTADO    = D.SGESTADO,
       @OLD_CDMUNICIPIO = D.CDMUNICIPIO,
       @OLD_CDBAIRRO    = D.CDBAIRRO,
       @OLD_NMBAIRRO    = D.NMBAIRRO,
       @NEW_NMBAIRRO    = I.NMBAIRRO
   FROM
      INSERTED I, DELETED D
   WHERE I.CDPAIS      = D.CDPAIS
     AND I.SGESTADO    = D.SGESTADO
     AND I.CDMUNICIPIO = D.CDMUNICIPIO
     AND I.CDBAIRRO    = D.CDBAIRRO;

   IF (@NEW_NMBAIRRO <> @OLD_NMBAIRRO) BEGIN
      SELECT
         @V_COUNT = COUNT(*)
      FROM
         ENDECLIE
      WHERE CDPAIS      = @OLD_CDPAIS
        AND SGESTADO    = @OLD_SGESTADO
        AND CDMUNICIPIO = @OLD_CDMUNICIPIO
        AND CDBAIRRO    = @OLD_CDBAIRRO;

      IF (@V_COUNT > 0) BEGIN
         UPDATE ENDECLIE
         SET NMBAIRCLIE = @NEW_NMBAIRRO
         WHERE CDPAIS      = @OLD_CDPAIS
           AND SGESTADO    = @OLD_SGESTADO
           AND CDMUNICIPIO = @OLD_CDMUNICIPIO
           AND CDBAIRRO    = @OLD_CDBAIRRO;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_NMBAIRRO','5.05.003';
GO

